#ifndef ARRDUMP_EVENT_H
#define ARRDUMP_EVENT_H

#include "event/arrDump/ArrDumpRecord.h"
#include <TClonesArray.h>

using namespace std;

namespace pamela {
  /**
   * ArrDumpEvent data Wrapper
   */
  class ArrDumpEvent: public pamela::SubPacket {
  private:
    static TClonesArray *fgRecords;
  public:
    /**
     * Get the run name according to a certain run number.
     * @param run Run number.
     * @return a string with the run name.
     */
    TClonesArray* Records;
    UINT32          PARAMETER_STAMP;

    ArrDumpEvent(void);
    ~ArrDumpEvent(void);
    
    ClassDef(ArrDumpEvent, 1)
  };
}

#endif /* ARRDUMP_EVENT_H */

