/** @file
 * $Source: /home/cvsmanager/yoda/event/tmtc/TmtcEvent.h,v $
 * $Id: TmtcEvent.h,v 3.0 2005/03/04 15:54:11 kusanagi Exp $
 * $Author: kusanagi $
 * 
 * Header file for the TmtcEvent class.
 */
#ifndef TMTC_EVENT_H
#define TMTC_EVENT_H

#include <vector>
#include "event/SubPacket.h"
#include "event/tmtc/TmtcRecord.h"
#include <TClonesArray.h>

using namespace std;

namespace pamela {
  /**
   * TmtcEvent data Wrapper
   */
  class TmtcEvent: public pamela::SubPacket {
  private:
    static TClonesArray *fgRecords;
  public:
    /**
     * Get the run name according to a certain run number.
     * @param run Run number.
     * @return a string with the run name.
     */
    TClonesArray* Records;
    
    TmtcEvent(void);
    ~TmtcEvent(void);
    
    ClassDef(TmtcEvent, 1)
  };
}

#endif /* TMTC_EVENT_H */

