#ifndef VARDUMP_EVENT_H
#define VARDUMP_EVENT_H

#include "event/varDump/VarDumpRecord.h"
#include <TClonesArray.h>

using namespace std;

namespace pamela {
  /**
   * VarDumpEvent data Wrapper
   */
  class VarDumpEvent: public pamela::SubPacket {
  private:
    static TClonesArray *fgRecords;
  public:
    /**
     * Get the run name according to a certain run number.
     * @param run Run number.
     * @return a string with the run name.
     */
    TClonesArray*   Records;
    UINT32          PARAMETER_STAMP;

    VarDumpEvent(void);
    ~VarDumpEvent(void);
    
    ClassDef(VarDumpEvent, 1)
  };
}

#endif /* VARDUMP_EVENT_H */

